%Copyright (C) 2018 Peter Munro
%
%This program is free software: you can redistribute it and/or modify
%it under the terms of the GNU Lesser Public License as published by
%the Free Software Foundation, either version 3 of the License, or
%(at your option) any later version.
%
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU Lesser Public License for more details.
%    
%You should have received a copy of the GNU Lesser Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.

%set this to 1 to recompute all field quantities
recompute = 0;

%refractive index profile
nvec = [1. 1.54 1.33];
hvec = [-170e-6 0];

%beam parameters
lambda = 488e-9;
NA = 0.9;

%number of values of theta and phi to integrate over
ntheta = 1000;
nphi = 1000;

%this location where the field will evaluated. Note that this lies
%on the optical axis, 50 microns after the last interface.
x = 0;
y = 0;
z = 50e-6;
[X,Y,Z] = ndgrid(x,y,z);
vertices = [X(:) Y(:) Z(:)];

%the PSF is calculated by shifting the statified medium and probe
%vertex axially relative to the focus.
delta_z = linspace(-50e-6,-10e-6,301);

Eacc = zeros(numel(delta_z),3);
if recompute
    parfor i=1:numel(delta_z)
	[Ep,Em] = focstratfield_general_pol(vertices+[0 0 delta_z(i)],nvec,hvec+delta_z(i),NA,lambda,ntheta,nphi,@xlin_pol_comp_ideal);
	Eacc(i,:) = Ep(:);
    end
    save cff05vars Eacc delta_z;
else
    load cff05vars;
end
